# geos::index::chain::MonotoneChain Class Reference

MonotoneChains are a way of partitioning the segments of a linestring to allow for fast searching of intersections. More...

`#include <MonotoneChain.h>`

List of all members.

## Public Member Functions

| MonotoneChain (const geom::CoordinateSequence *newPts, int nstart, int nend, void *nContext)
geom::Envelope * | getEnvelope ()
int | getStartIndex ()
int | getEndIndex ()
void | getLineSegment (unsigned int index, geom::LineSegment *ls)
geom::CoordinateSequence * | getCoordinates ()
void | select (const geom::Envelope &searchEnv, MonotoneChainSelectAction &mcs)
void | computeOverlaps (MonotoneChain *mc, MonotoneChainOverlapAction *mco)
void | setId (int nId)
int | getId ()
void * | getContext ()

## Detailed Description

MonotoneChains are a way of partitioning the segments of a linestring to allow for fast searching of intersections.

They have the following properties:

- the segments within a monotone chain will never intersect each other
- the envelope of any contiguous subset of the segments in a monotone chain is equal to the envelope of the endpoints of the subset.

Property 1 means that there is no need to test pairs of segments from within the same monotone chain for intersection. Property 2 allows binary search to be used to find the intersection points of two monotone chains. For many types of real-world data, these properties eliminate a large number of segment comparisons, producing substantial speed gains.

One of the goals of this implementation of MonotoneChains is to be as space and time efficient as possible. One design choice that aids this is that a MonotoneChain is based on a subarray of a list of points. This means that new arrays of points (potentially very large) do not have to be allocated.

MonotoneChains support the following kinds of queries:

- Envelope select: determine all the segments in the chain which intersect a given envelope
- Overlap: determine all the pairs of segments in two chains whose envelopes overlap

This implementation of MonotoneChains uses the concept of internal iterators to return the resultsets for the above queries. This has time and space advantages, since it is not necessary to build lists of instantiated objects to represent the segments returned by the query. However, it does mean that the queries are not thread-safe.

Last port: index/chain/MonotoneChain.java rev. 1.13 (JTS-1.7)

## Member Function Documentation

geom::CoordinateSequence* geos::index::chain::MonotoneChain::getCoordinates | ( |  | ) |

Return the subsequence of coordinates forming this chain. Allocates a new CoordinateSequence to hold the Coordinates

void geos::index::chain::MonotoneChain::select | ( | const geom::Envelope & | searchEnv,
|  | MonotoneChainSelectAction & | mcs |
| ) |  |  |

Determine all the line segments in the chain whose envelopes overlap the searchEnvelope, and process them

The documentation for this class was generated from the following file:

- index/chain/MonotoneChain.h